class PhaserModelWrapper(Module):
  __parameters__ = []
  __buffers__ = ["default_param_values", ]
  default_param_values : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  MAX_N_PARAMS : int
  SDK_VERSION : str
  CURRENT_TIME : float
  use_debug_mode : bool
  n_neutone_parameters : int
  neutone_parameters_metadata : Dict[str, Dict[str, str]]
  remapped_params : Dict[str, Tensor]
  neutone_parameter_names : List[str]
  neutone_parameter_descriptions : List[str]
  neutone_parameter_used : List[bool]
  neutone_parameter_types : List[str]
  in_n_ch : int
  curr_bs : int
  in_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  params_queue : __torch__.neutone_sdk.queues.CircularInplaceTensorQueue
  model_in_buffer : Tensor
  params_buffer : Tensor
  agg_params : Tensor
  model : __torch__.PhaserModel
  def forward(self: __torch__.PhaserModelWrapper,
    x: Tensor,
    params: Optional[Tensor]=None) -> Tensor:
    _0 = __torch__.neutone_sdk.utils.validate_waveform
    _1 = "Invalid model input audio length of {} samples, must be of length {} samples"
    _2 = "The model does not support a buffer size of {}"
    _3 = "AssertionError: Model uses a look-behind buffer, but the incoming buffer size has not been set. Be sure to call `set_sample_rate_and_buffer_size` before using the model."
    _4 = "Invalid model output audio length of {} samples, must be of length {} samples (are you using a look behind buffer incorrectly?)"
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _5 = _0(x, (self).is_input_mono(), )
    else:
      pass
    in_n = torch.size(x, 1)
    if torch.__is__(params, None):
      params1 = torch.repeat((self).get_default_param_values(), [1, in_n])
      params0 = params1
    else:
      params0 = unchecked_cast(Tensor, params)
    use_debug_mode0 = self.use_debug_mode
    if use_debug_mode0:
      _6 = torch.size(params0)
      MAX_N_PARAMS = self.MAX_N_PARAMS
      _7 = torch.eq(_6, [MAX_N_PARAMS, in_n])
      if _7:
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      curr_bs = self.curr_bs
      if torch.ne(curr_bs, -1):
        curr_bs0 = self.curr_bs
        if torch.eq(in_n, curr_bs0):
          pass
        else:
          curr_bs1 = self.curr_bs
          _8 = torch.format(_1, in_n, curr_bs1)
          _9 = torch.add("AssertionError: ", _8)
          ops.prim.RaiseException(_9)
      else:
        _10 = (self).get_native_buffer_sizes()
        if torch.gt(torch.len(_10), 0):
          _11 = (self).get_native_buffer_sizes()
          if torch.__contains__(_11, in_n):
            pass
          else:
            _12 = torch.add("AssertionError: ", torch.format(_2, in_n))
            ops.prim.RaiseException(_12)
        else:
          pass
      _13 = bool((self).get_look_behind_samples())
      if _13:
        curr_bs2 = self.curr_bs
        if torch.ne(curr_bs2, -1):
          pass
        else:
          ops.prim.RaiseException(_3)
      else:
        pass
    else:
      pass
    _14 = bool((self).get_look_behind_samples())
    if _14:
      in_queue = self.in_queue
      _15 = (in_queue).push(x, )
      params_queue = self.params_queue
      _16 = (params_queue).push(params0, )
      in_queue0 = self.in_queue
      size = in_queue0.size
      model_in_buffer = self.model_in_buffer
      _17 = torch.slice(torch.slice(model_in_buffer), 1, 0, torch.neg(size))
      _18 = torch.tensor(0, dtype=ops.prim.dtype(_17), device=ops.prim.device(_17))
      _19 = torch.copy_(_17, _18)
      in_queue1 = self.in_queue
      model_in_buffer0 = self.model_in_buffer
      _20 = torch.slice(torch.slice(model_in_buffer0), 1, torch.neg(size))
      _21 = (in_queue1).fill(_20, )
      _22 = (self).get_default_param_values()
      params_buffer = self.params_buffer
      _23 = torch.slice(torch.slice(params_buffer), 1, 0, torch.neg(size))
      _24 = torch.copy_(_23, _22)
      params_queue0 = self.params_queue
      params_buffer0 = self.params_buffer
      _25 = torch.slice(torch.slice(params_buffer0), 1, torch.neg(size))
      _26 = (params_queue0).fill(_25, )
      model_in_buffer1 = self.model_in_buffer
      params2, x0 = self.params_buffer, model_in_buffer1
    else:
      params2, x0 = params0, x
    params3 = (self).aggregate_params(params2, )
    use_debug_mode1 = self.use_debug_mode
    if use_debug_mode1:
      if torch.eq(torch.dim(params3), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
      _27 = torch.size(params3, 0)
      MAX_N_PARAMS0 = self.MAX_N_PARAMS
      if torch.eq(_27, MAX_N_PARAMS0):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    n_neutone_parameters = self.n_neutone_parameters
    for idx in range(n_neutone_parameters):
      _28 = torch.select(params3, 0, idx)
      remapped_params = self.remapped_params
      neutone_parameter_names = self.neutone_parameter_names
      torch._set_item(remapped_params, neutone_parameter_names[idx], _28)
    remapped_params0 = self.remapped_params
    x1 = (self).do_forward_pass(x0, remapped_params0, )
    use_debug_mode2 = self.use_debug_mode
    if use_debug_mode2:
      _29 = _0(x1, (self).is_output_mono(), )
      curr_bs3 = self.curr_bs
      if torch.eq(curr_bs3, -1):
        _30 = torch.eq(torch.size(x1, 1), in_n)
        if _30:
          pass
        else:
          ops.prim.RaiseException("AssertionError: ")
      else:
        _31 = torch.size(x1, 1)
        curr_bs4 = self.curr_bs
        if torch.eq(_31, curr_bs4):
          pass
        else:
          _32 = torch.size(x1, 1)
          curr_bs5 = self.curr_bs
          _33 = torch.format(_4, _32, curr_bs5)
          _34 = torch.add("AssertionError: ", _33)
          ops.prim.RaiseException(_34)
    else:
      pass
    return x1
  def calc_model_delay_samples(self: __torch__.PhaserModelWrapper) -> int:
    return 0
  def get_core_preserved_attributes(self: __torch__.PhaserModelWrapper) -> List[str]:
    _35 = ["model", "get_neutone_parameters_metadata", "get_default_param_values", "get_default_param_names", "get_default_param_descriptions", "get_default_param_types", "get_default_param_used", "get_wet_default_value", "get_dry_default_value", "get_input_gain_default_value", "get_output_gain_default_value", "get_core_preserved_attributes", "to_core_metadata"]
    return _35
  def get_default_param_descriptions(self: __torch__.PhaserModelWrapper) -> List[str]:
    return self.neutone_parameter_descriptions
  def get_default_param_names(self: __torch__.PhaserModelWrapper) -> List[str]:
    return self.neutone_parameter_names
  def get_default_param_types(self: __torch__.PhaserModelWrapper) -> List[str]:
    return self.neutone_parameter_types
  def get_default_param_used(self: __torch__.PhaserModelWrapper) -> List[bool]:
    return self.neutone_parameter_used
  def get_default_param_values(self: __torch__.PhaserModelWrapper) -> Tensor:
    return self.default_param_values
  def get_dry_default_value(self: __torch__.PhaserModelWrapper) -> float:
    return 0.
  def get_input_gain_default_value(self: __torch__.PhaserModelWrapper) -> float:
    return 0.5
  def get_native_buffer_sizes(self: __torch__.PhaserModelWrapper) -> List[int]:
    model = self.model
    use_fs = model.use_fs
    if use_fs:
      _37 = annotate(List[int], [])
      model0 = self.model
      win_len = model0.win_len
      model1 = self.model
      win_len0 = model1.win_len
      _38 = ops.prim.max(torch.add(win_len0, 1), 10000)
      model2 = self.model
      hop_len = model2.hop_len
      _39 = torch.__range_length(win_len, _38, hop_len)
      for _40 in range(_39):
        bs = torch.__derive_index(_40, win_len, hop_len)
        _41 = torch.append(_37, bs)
      _36 = _37
    else:
      _36 = annotate(List[int], [])
    return _36
  def get_native_sample_rates(self: __torch__.PhaserModelWrapper) -> List[int]:
    model = self.model
    sr = model.sr
    return [sr]
  def get_neutone_parameters_metadata(self: __torch__.PhaserModelWrapper) -> Dict[str, Dict[str, str]]:
    return self.neutone_parameters_metadata
  def get_output_gain_default_value(self: __torch__.PhaserModelWrapper) -> float:
    return 0.5
  def get_preserved_attributes(self: __torch__.PhaserModelWrapper) -> List[str]:
    _42 = "set_daw_sample_rate_and_buffer_size"
    preserved_attrs = (self).get_core_preserved_attributes()
    _43 = ["is_input_mono", "is_output_mono", "get_native_sample_rates", "get_native_buffer_sizes", "is_resampling", "calc_model_delay_samples", "set_sample_rate_and_buffer_size", _42, "reset", "get_preserved_attributes", "to_metadata"]
    torch.extend(preserved_attrs, _43)
    return preserved_attrs
  def get_wet_default_value(self: __torch__.PhaserModelWrapper) -> float:
    return 1.
  def is_input_mono(self: __torch__.PhaserModelWrapper) -> bool:
    return False
  def is_output_mono(self: __torch__.PhaserModelWrapper) -> bool:
    return False
  def is_resampling(self: __torch__.PhaserModelWrapper) -> bool:
    return False
  def reset(self: __torch__.PhaserModelWrapper) -> bool:
    in_queue = self.in_queue
    _44 = (in_queue).reset()
    params_queue = self.params_queue
    _45 = (params_queue).reset()
    model_in_buffer = self.model_in_buffer
    _46 = torch.fill_(model_in_buffer, 0)
    _47 = (self).get_default_param_values()
    params_buffer = self.params_buffer
    _48 = torch.slice(torch.slice(params_buffer), 1)
    _49 = torch.copy_(_48, _47)
    return (self).reset_model()
  def reset_model(self: __torch__.PhaserModelWrapper) -> bool:
    model = self.model
    _50 = (model).reset()
    return True
  def set_daw_sample_rate_and_buffer_size(self: __torch__.PhaserModelWrapper,
    daw_sr: int,
    daw_buffer_size: int,
    model_sr: Optional[int]=None,
    model_buffer_size: Optional[int]=None) -> NoneType:
    _51 = (self).set_sample_rate_and_buffer_size(daw_sr, daw_buffer_size, )
    return None
  def set_sample_rate_and_buffer_size(self: __torch__.PhaserModelWrapper,
    sample_rate: int,
    n_samples: int) -> bool:
    _52 = "The model does not support a native buffer size of {}"
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      _53 = torch.len((self).get_native_buffer_sizes())
      if torch.gt(_53, 0):
        _54 = (self).get_native_buffer_sizes()
        _55 = torch.__contains__(_54, n_samples)
        if _55:
          pass
        else:
          _56 = torch.add("AssertionError: ", torch.format(_52, n_samples))
          ops.prim.RaiseException(_56)
      else:
        pass
    else:
      pass
    _57 = bool((self).get_look_behind_samples())
    if _57:
      curr_bs = self.curr_bs
      if torch.eq(curr_bs, -1):
        _58 = True
      else:
        curr_bs6 = self.curr_bs
        _58 = torch.ne(n_samples, curr_bs6)
      if _58:
        self.curr_bs = n_samples
        _59 = (self).get_look_behind_samples()
        curr_bs7 = self.curr_bs
        queue_len = torch.add(_59, curr_bs7)
        in_n_ch = self.in_n_ch
        use_debug_mode3 = self.use_debug_mode
        _60 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
        _61 = (_60).__init__(in_n_ch, queue_len, use_debug_mode3, )
        self.in_queue = _60
        MAX_N_PARAMS = self.MAX_N_PARAMS
        use_debug_mode4 = self.use_debug_mode
        _62 = __torch__.neutone_sdk.queues.CircularInplaceTensorQueue.__new__(__torch__.neutone_sdk.queues.CircularInplaceTensorQueue)
        _63 = (_62).__init__(MAX_N_PARAMS, queue_len, use_debug_mode4, )
        self.params_queue = _62
        in_n_ch0 = self.in_n_ch
        _64 = torch.zeros([in_n_ch0, queue_len])
        self.model_in_buffer = _64
        _65 = (self).get_default_param_values()
        _66 = torch.repeat(_65, [1, queue_len])
        self.params_buffer = _66
      else:
        pass
    else:
      pass
    _67 = (self).set_model_sample_rate_and_buffer_size(sample_rate, n_samples, )
    return _67
  def to_core_metadata(self: __torch__.PhaserModelWrapper) -> __torch__.neutone_sdk.core.CoreMetadata:
    _68 = (self).get_model_name()
    _69 = (self).get_model_authors()
    _70 = (self).get_model_short_description()
    _71 = (self).get_model_long_description()
    _72 = (self).get_neutone_parameters_metadata()
    _73 = (self).get_wet_default_value()
    _74 = (self).get_dry_default_value()
    _75 = (self).get_input_gain_default_value()
    _76 = (self).get_output_gain_default_value()
    _77 = (self).get_technical_description()
    _78 = (self).get_technical_links()
    _79 = (self).get_tags()
    _80 = (self).get_model_version()
    SDK_VERSION = self.SDK_VERSION
    CURRENT_TIME = self.CURRENT_TIME
    _81 = __torch__.neutone_sdk.core.CoreMetadata(_68, _69, _70, _71, _77, _78, _72, _73, _74, _75, _76, _79, _80, SDK_VERSION, CURRENT_TIME, "2.1.2", (self).get_citation(), (self).is_experimental())
    return _81
  def to_metadata(self: __torch__.PhaserModelWrapper) -> __torch__.neutone_sdk.wavform_to_wavform.WaveformToWaveformMetadata:
    core_metadata = (self).to_core_metadata()
    _82 = (core_metadata)[0]
    _83 = (core_metadata)[1]
    _84 = (core_metadata)[2]
    _85 = (core_metadata)[3]
    _86 = (core_metadata)[6]
    _87 = (core_metadata)[7]
    _88 = (core_metadata)[8]
    _89 = (core_metadata)[9]
    _90 = (core_metadata)[10]
    _91 = (core_metadata)[4]
    _92 = (core_metadata)[5]
    _93 = (core_metadata)[11]
    _94 = (core_metadata)[12]
    _95 = (core_metadata)[13]
    _96 = (core_metadata)[15]
    _97 = (core_metadata)[14]
    _98 = (core_metadata)[16]
    _99 = (core_metadata)[17]
    _100 = (self).is_input_mono()
    _101 = (self).is_output_mono()
    if (self).is_input_mono():
      _102 = "mono"
    else:
      _102 = "stereo"
    if (self).is_output_mono():
      _103 = "mono"
    else:
      _103 = "stereo"
    _104 = torch.format("{}-{}", _102, _103)
    _105 = (self).get_native_buffer_sizes()
    _106 = __torch__.neutone_sdk.wavform_to_wavform.WaveformToWaveformMetadata(_82, _83, _94, _84, _85, _91, _92, _93, _98, _99, _86, _87, _88, _89, _90, _100, _101, _104, (self).get_native_sample_rates(), _105, (self).get_look_behind_samples(), _95, _96, _97)
    return _106
  def get_look_behind_samples(self: __torch__.PhaserModelWrapper) -> int:
    return 0
  def aggregate_params(self: __torch__.PhaserModelWrapper,
    params: Tensor) -> Tensor:
    use_debug_mode = self.use_debug_mode
    if use_debug_mode:
      if torch.eq(torch.dim(params), 2):
        pass
      else:
        ops.prim.RaiseException("AssertionError: ")
    else:
      pass
    agg_params = self.agg_params
    _107 = torch.mean(params, [1], True, out=agg_params)
    return self.agg_params
  def do_forward_pass(self: __torch__.PhaserModelWrapper,
    x: Tensor,
    params: Dict[str, Tensor]) -> Tensor:
    x2 = torch.to(x, 7)
    lfo_rate_0to1 = params["lfo_rate"]
    lfo_stereo_offset_0to1 = params["lfo_stereo_offset"]
    model = self.model
    y = (model).forward(x2, lfo_rate_0to1, lfo_stereo_offset_0to1, )
    return y
  def set_model_sample_rate_and_buffer_size(self: __torch__.PhaserModelWrapper,
    sample_rate: int,
    n_samples: int) -> bool:
    return False
  def get_model_name(self: __torch__.PhaserModelWrapper) -> str:
    model = self.model
    use_fs = model.use_fs
    if use_fs:
      model3 = self.model
      model_key = model3.model_key
      model4 = self.model
      win_len = model4.win_len
      _109 = torch.format("phaser_model_{}_fs_{}", model_key, win_len)
      _108 = _109
    else:
      model5 = self.model
      model_key0 = model5.model_key
      _110 = torch.format("phaser_model_{}_td", model_key0)
      _108 = _110
    return _108
  def get_model_authors(self: __torch__.PhaserModelWrapper) -> List[str]:
    return ["Alistair Carson"]
  def get_model_short_description(self: __torch__.PhaserModelWrapper) -> str:
    return "DDSP phaser implementation."
  def get_model_long_description(self: __torch__.PhaserModelWrapper) -> str:
    _111 = "DDSP phaser implementation for \'Differentiable All-pole Filters for Time-varying Audio Systems\'."
    return _111
  def get_technical_description(self: __torch__.PhaserModelWrapper) -> str:
    _112 = "Wrapper for a DDSP phaser implementation that models an Electro-Harmonix Small Stone phaser pedal."
    return _112
  def get_technical_links(self: __torch__.PhaserModelWrapper) -> Dict[str, str]:
    _113 = "https://github.com/DiffAPF/EHX-SmallStone"
    return {"Code": _113}
  def get_tags(self: __torch__.PhaserModelWrapper) -> List[str]:
    _114 = ["phaser", "ddsp", "EHX Small Stone"]
    return _114
  def get_model_version(self: __torch__.PhaserModelWrapper) -> str:
    return "1.0.0"
  def get_citation(self: __torch__.PhaserModelWrapper) -> str:
    return ""
  def is_experimental(self: __torch__.PhaserModelWrapper) -> bool:
    return True
class PhaserModel(Module):
  __parameters__ = []
  __buffers__ = ["prev_phase", "zi", ]
  prev_phase : Tensor
  zi : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  model_key : str
  sr : int
  min_lfo_rate_hz : float
  max_lfo_rate_hz : float
  use_fs : bool
  win_len : int
  hop_len : int
  model : __torch__.phaser.Phaser
  def forward(self: __torch__.PhaserModel,
    x: Tensor,
    lfo_rate_0to1: Tensor,
    lfo_stereo_phase_offset_0to1: Tensor) -> Tensor:
    if torch.eq(torch.dim(x), 2):
      pass
    else:
      ops.prim.RaiseException("AssertionError: ")
    max_lfo_rate_hz = self.max_lfo_rate_hz
    min_lfo_rate_hz = self.min_lfo_rate_hz
    _115 = torch.sub(max_lfo_rate_hz, min_lfo_rate_hz)
    _116 = torch.mul(lfo_rate_0to1, _115)
    min_lfo_rate_hz0 = self.min_lfo_rate_hz
    lfo_rate = torch.add(_116, min_lfo_rate_hz0)
    _117 = torch.mul(lfo_stereo_phase_offset_0to1, 2)
    lfo_stereo_phase_offset = torch.mul(_117, 3.1415926535897931)
    _118 = torch.size(x, -1)
    _119 = torch.item(lfo_rate)
    prev_phase = self.prev_phase
    _120 = torch.item(prev_phase)
    arg_l = (self).make_argument(_118, float(_119), float(_120), )
    next_phase = torch.remainder(torch.select(arg_l, 0, -1), 6.2831853071795862)
    self.prev_phase = next_phase
    arg_r = torch.add(arg_l, lfo_stereo_phase_offset)
    arg = torch.stack([arg_l, arg_r])
    model = self.model
    lfo = model.lfo
    amp = lfo.amp
    lfo0 = torch.mul(amp, torch.cos(arg))
    lfo1 = torch.unsqueeze(lfo0, 2)
    model6 = self.model
    bias = model6.bias
    model7 = self.model
    depth = model7.depth
    _121 = torch.mul(depth, 0.5)
    model8 = self.model
    mlp = model8.mlp
    _122 = torch.squeeze((mlp).forward(lfo1, ))
    _123 = torch.mul(_121, torch.add(_122, 1.))
    d = torch.add(bias, _123)
    _124 = torch.add(torch.neg(torch.tan(d)), 1.)
    _125 = torch.div(_124, torch.add(torch.tan(d), 1.))
    p = torch.tanh(_125)
    use_fs = self.use_fs
    if use_fs:
      model9 = self.model
      x4 = (model9).forward_frame_based(x, p, )
      x3 = x4
    else:
      model10 = self.model
      zi = self.zi
      _126 = (model10).forward_sample_based(x, p, zi, )
      x5, next_zi, = _126
      _127 = torch.slice(torch.slice(next_zi), 1)
      zi0 = self.zi
      _128 = torch.copy_(torch.slice(torch.slice(zi0), 1), _127)
      x3 = x5
    return x3
  def make_argument(self: __torch__.PhaserModel,
    n_samples: int,
    freq: float,
    phase: float) -> Tensor:
    _129 = torch.full([n_samples], freq, dtype=7)
    _130 = torch.mul(_129, 6.2831853071795862)
    sr = self.sr
    _131 = torch.cumsum(torch.div(_130, sr), 0)
    return torch.add(_131, phase)
  def reset(self: __torch__.PhaserModel) -> NoneType:
    prev_phase = self.prev_phase
    _132 = torch.zero_(prev_phase)
    zi = self.zi
    _133 = torch.zero_(zi)
    return None
